/* WGProcess.m created by epeyton on Tue 17-Aug-1999 */

#import "WGProcess.h"

@implementation WGProcess

- (void)awakeFromNib
{
    [startButton setEnabled:YES];
    [stopButton setEnabled:NO];
    [pauseButton setEnabled:NO];
    return;
}


- (void)run:(id)sender
{
    NSMutableArray *args = [NSMutableArray arrayWithObject:[[NSBundle mainBundle] pathForResource:@"pavuk" ofType:@""]];

    [args addObjectsFromArray:[parentController optionsForRun]];
    [args addObjectsFromArray:[parentController urlsForRun]];
    
    [tabView selectTabViewItemAtIndex:[[tabView tabViewItems] count] - 1];

    [self theTask:args];

    [stopButton setEnabled:YES];
    [startButton setEnabled:NO];
    
    return; 
}

- (BOOL)isRunning
{
    if (chore) {
        return YES;
    }
    return NO;
}

- (void)stop:(id)sender
{
    [[NSNotificationCenter defaultCenter] removeObserver:self 
            name: NSFileHandleReadCompletionNotification 
            object: [[chore standardOutput] fileHandleForReading]];
            
    
    [self getData:nil];
    
    [chore terminate];

    return;
}

- (void)pause:(id)sender
{
    return;
}

- (void)clear:(id)sender
{
    NSRange theRange;

    theRange.length = [[resultField string] length];
    theRange.location = 0;
    [resultField setEditable:YES];

    [resultField setSelectedRange:theRange];

    [resultField insertText:@""];				/* clear the field */
    [resultField setEditable:NO];

    return;
}


- (void)theTask:(NSArray *)args
{
    NSPipe		*commPipe = [NSPipe pipe];
    NSRange			rArgList ;

    chore = [[NSTask alloc] init];

    //NSLog(@"%@", args);

    [chore setStandardOutput:commPipe];
    [chore setStandardError:commPipe];
    [chore setLaunchPath:[args objectAtIndex:0]];
    rArgList = NSMakeRange (1, ([args count] - 1)) ;
    [chore setArguments:[args subarrayWithRange:rArgList]];
    
    [[NSNotificationCenter defaultCenter] addObserver:self
        selector:@selector(getData:)
        name:NSFileHandleReadCompletionNotification
        object: [[chore standardOutput] fileHandleForReading]];
        
    [[[chore standardOutput] fileHandleForReading] readInBackgroundAndNotify];    
    
    [chore launch];

}

- (void) getData: (NSNotification *)aNotification
{
    NSString *output;
    NSRange theRange;

    NSData *data = [[aNotification userInfo] objectForKey:NSFileHandleNotificationDataItem];

    if(data == nil || [data length] == 0) {
        // Add a red trailer to mark the end of output.
        theRange.length = 0;
        theRange.location = [[resultField string] length];
        [resultField setEditable:YES];
        [resultField setSelectedRange:theRange];
        [resultField insertText:@"\n*********DOWNLOAD COMPLETE***********\n\n"];
        theRange.length = 38 ;
        [resultField setTextColor:[NSColor redColor] range:theRange];
        [resultField setEditable:NO];


        // A nil message marks the end of this task's output.
        // Enable the go button.
        [startButton setEnabled:YES];
        [stopButton setEnabled:NO];
        [[NSNotificationCenter defaultCenter] removeObserver:self 
            name: NSFileHandleReadCompletionNotification 
            object: [[chore standardOutput] fileHandleForReading]];
            
        [chore terminate];    
    } else {
        output = [NSString stringWithCString:[data bytes] length:[data length]];
        [self printResults:output];
    }
    
    if (chore)
    {
        [[aNotification object] readInBackgroundAndNotify];
    }
}

////////////////////////////////////////////////////////////////////////////////////////
//Prints the title in red.
////////////////////////////////////////////////////////////////////////////////////////
- (void)printTitle:(NSString *)header query:(NSString *)query
{
    NSRange theRange;

    theRange.length = 0;					/* Select the last character */
    theRange.location = [[resultField string] length];
    [resultField setEditable:YES];

    [resultField setSelectedRange:theRange];

    if(header != nil) {						/* Add the header */

        [resultField insertText:@"\n******** "];			
        [resultField insertText:header];
        [resultField insertText:@": "];
        [resultField insertText:query];
        [resultField insertText:@" ********\n"];

        theRange.length = [header length] + [query length] + 22;	/* Make the header red */
        theRange.location = [[resultField string] length] - theRange.length;
        [resultField setTextColor:[NSColor redColor] range:theRange];
    }

    [resultField insertText:@"\n"];
    [resultField setEditable:NO];

}

////////////////////////////////////////////////////////////////////////////////////////
//Prints the results in black.
////////////////////////////////////////////////////////////////////////////////////////
- (void)printResults:(NSString *)result
{
    NSRange theRange;

    theRange.length = 0;					/* Select the last character */
    theRange.location = [[resultField string] length];
    [resultField setEditable:YES];

    [resultField setSelectedRange:theRange];
	
    [resultField insertText:result];				/* Add the result */
    theRange.length = [result length];
    theRange.location = [[resultField string] length] - theRange.length;
    [resultField setTextColor:[NSColor blackColor] range:theRange];
    [resultField setEditable:NO];


}

@end
